
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java.util.concurrent解析——AbstractQueuedSynchronizer队列管理 / iVAN</title>

    <meta name="description" content="java.util.concurrent解析——AbstractQueuedSynchronizer队列管理 上一篇博客中,我们提到AQS的队列管理是基于CLH锁队列实现的,所以首先我们来看下CLH锁队列. 1 CLH锁队列 CLH锁队列本质上是一个基于链表的FIFO自旋锁队列,队列中的每一个节点实质上是一个自旋锁:在阻塞时不断循环读取状态变量,当前驱节点释放同步对象使用权后,跳出循环,执行同步代码.其基本结构如下: 队列中每一个节点有两个成员: 节点状态变量 前驱指针:pred head,tail并不是实际节点,只是为了表示队列的首尾,被称为dumb node. 在如此结构之下,其enqueue操作逻">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">java.util.concurrent解析——AbstractQueuedSynchronizer队列管理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>上一篇博客中，我们提到<code>AQS</code>的队列管理是基于CLH锁队列实现的，所以首先我们来看下<code>CLH锁队列</code>。</p>
<h3>1 CLH锁队列</h3>
<p><code>CLH锁队列</code>本质上是一个基于链表的FIFO自旋锁队列，队列中的每一个节点实质上是一个自旋锁：在阻塞时不断循环读取状态变量，当前驱节点释放同步对象使用权后，跳出循环，执行同步代码。其基本结构如下：<br /><a href="http://img.blog.csdn.net/20170725203514050?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvYXNpYUxJWUFaSE9V/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA3MjUyMDM1MTQwNTA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WVhOcFlVeEpXVUZhU0U5Vi9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></a></p>
<p>队列中每一个节点有两个成员：</p>
<ul>
<li>节点状态变量</li>
<li>前驱指针：pred</li>
</ul>
<p>head,tail并不是实际节点，只是为了表示队列的首尾，被称为dumb node。</p>
<p>在如此结构之下，其enqueue操作逻辑如下：</p>
<pre><code>do { pred = tail;
} while(!tail.compareAndSet(pred, node));
</code></pre>
<p>其lock操作如下：</p>
<pre><code>public void lock() {
  final Node node = new Node();
  node.locked = true;
  // 一个CAS操作即可将当前线程对应的节点加入到队列中，
  // 并且同时获得了前继节点的引用，然后就是等待前继释放锁
  Node pred = this.tail.getAndSet(node);
  this.prev.set(pred);
  while (pred.locked) {// 进入自旋
  }
}
</code></pre>
<p>可以看到其自旋逻辑。</p>
<p>而其dequeue操做更加简单：</p>
<pre><code>head = node;
</code></pre>
<p>从面的操作，可以看到<code>CLH锁队列</code>有如下优势：</p>
<ul>
<li>队列的入列、出列操作原子性完成，无需加锁，高效</li>
<li>判断当前队列等待是否为空同样简单，只需检查head是否为tail即可</li>
<li>每个节点独立维护其状态变量，避免了集中状态管理的内存竞争</li>
</ul>
<h3>2 <code>AQS</code>进程队列</h3>
<p><code>AQS</code>进程队列相比于<code>CLH锁队列</code>主要做了两处修改：</p>
<ul>
<li>每个节点新增一个next指针。由于<code>AQS</code>队列中的进程不仅有自旋等待，还包括阻塞等待的情况。阻塞等待的队列需要其他队列主动唤醒。这就要求队列中某个节点出列时需要显式告知其后继节点，因而需要加入next指针</li>
<li>节点状态变量status由一个bit替换成一个int。这主要是由于<code>AQS</code>下的状态更加复杂</li>
</ul>
<p>首先来看下<code>AQS队列节点</code>的基本结构：</p>
<pre><code>static final class Node {
     // 表明节点是否以共享模式等待的标记
    static final Node SHARED = new Node();

    // 表明节点是否以独占模式等待的标记
    static final Node EXCLUSIVE = null;

    // 表明线程已被取消
    static final int CANCELLED =  1;

    // 表明后续节点的线程需要unparking
    static final int SIGNAL    = -1;

    // 表明线程正在等待一个条件
    static final int CONDITION = -2;

    // 表明下一次acquireShared应该无条件传播
    static final int PROPAGATE = -3;

    /*
     * 状态字段，只能取下面的值：
     * SIGNAL(-1)：    这个结点的后继是（或很快是）阻塞的（通过park），所以当前结点
     *              必须unpark它的后继，当它释放或取消时。为了避免竞争，acquire方法必须
     *              首先表明它们需要一个信号，然后再次尝试原子性acquire，如果失败了就阻塞。
     *
     * CANCELLED(1)：  这个结点由于超时或中断已被取消。结点从不离开这种状态。尤其是，
     *                 这种状态的线程从不再次阻塞。
     *
     * CONDITION(-2)： 这个结点当前在一个条件队列上。它将不会用于sync队列的结点，
     *               直到被转移，在那时，结点的状态将被设为0.
     *              这个值在这里的使用与其他字段的使用没有关系，仅仅是简化结构。
     *
     * PROPAGATE(-3)： releaseShared应该传递给其他结点。这是在doReleaseShared里设置
     *                 （仅仅是头结点）以确保传递继续，即使其他操作有干涉。
     *
     * 0：             非以上任何值。
     *
     * 值是组织为数字的用以简化使用。非负值表示结点不需要信号。这样，大部分代码不需要
     * 检查特定的值，只需要(检查)符号。
     *
     * 对于普通同步结点，字段初始化为0；对于条件结点初始化为CONDITION(-2)。
     * 通过CAS操作修改(或者，当允许时，用无条件volatile写。)
     */
    volatile int waitStatus;

    /*
     * 连接到当前结点/线程依赖的用来检查等待状态的前驱结点。
     * 在进入队列时赋值，只在出队列时置为空（为了GC考虑）。
     * 根据前驱结点的取消，我们使查找一个非取消结点的while循环短路，这个总是会退出，
     * 因为头结点从不会是取消了的：一个结点成为头只能是一次成功的acquire操作结果。
     *
     * 一个取消了的线程从不会在获取操作成功，线程只能取消自己，不能是其他结点。
     */
    volatile Node prev;

    /*
     * 连接到当前结点/线程释放时解除阻塞的后续结点。
     * 在入队列时赋值，在绕过已取消前驱节点时调整，出队列时置为空（for GC）。
     * 入队操作不会给前驱结点的next字段赋值，直到附件后（把新节点赋值给队列的tail属性？），
     * 所以看到next字段为空不一定表示它就是队列的尾结点。然而，如果next字段看起来是空，
     * 我们可以从tail向前遍历进行双重检查。
     * 被取消了的结点的next字段被设置为指向它自己而不是空，这让isOnSyncQueue变得容易。
     */
    volatile Node next;

    /*
     * 列队在这个结点的线程，在构造时初始化，用完后置空。
     */
    volatile Thread thread;

    /*
     * 连接到下一个在条件上等待的结点或是特殊的值SHARED。
     * 因为条件队列只在独占模式下持有时访问，我们只需要一个简单的链表队列来持有在条件上等待的结点。
     * 他们然后被转移到队列去re-acquire。
     * 因为条件只能是独占的，我们通过用一个特殊的值来表明共享模式 来节省一个字段。
     */
    Node nextWaiter;

    Node() {    // Used to establish initial head or SHARED marker
    }

    Node(Thread thread, Node mode) {     // Used by addWaiter
        this.nextWaiter = mode;
        this.thread = thread;
    }

    Node(Thread thread, int waitStatus) { // Used by Condition
        this.waitStatus = waitStatus;
        this.thread = thread;
    }
}
</code></pre>
<p>接下来我们就来看下其主要操作的主要逻辑。</p>
<h3>3 enqueue</h3>
<p>由于<code>AQS</code>队列节点包括pred和next两个指针，无法通过一次原子操作更新两个指针。所以添加结点到队列的操作最重要的是要保证：即使添加的CAS操作失败了，也不能影响队列结点现有的连接关系。</p>
<p>对于新加结点：</p>
<ul>
<li>在CAS之前指向它的预期前驱</li>
<li>CAS成功之后再更新预期前驱的后继指针。</li>
</ul>
<p>在步骤1成功之后、步骤2完成之前，其他线程通过结点的 “next” 连接可能看到“尾结点”（即代码里的 pred）的 “next” 为空，但其实队列里已经加入新的结点，这也是为什么通过 “next” 连接遍历队列时碰到后继为空的，必须从原子地更新的 “tail” 结点向后遍历。</p>
<pre><code>private Node addWaiter(Node mode) {
    Node node = new Node(Thread.currentThread(), mode);
   // 尝试enq的快速路径；失败后回退到完整的enq。
    Node pred = tail;
    if (pred != null) {
      // 把新结点的前驱指向pred，必须在下面的CAS完成之前设置，
      // 这样确保一旦CAS成功后，从tail向后遍历是ok的。
        node.prev = pred;// 步骤 1
        if (compareAndSetTail(pred, node)) {  //CAS
             // 新节点成功进入队列
             // 前驱结点的next字段指向新结点，建立完整的连接。
            pred.next = node; // 步骤 2
            return node;
        }
    }
    enq(node);
    return node;
}

private Node enq(final Node node) {
    for (;;) {
        Node t = tail;
        if (t == null) { // 队列是空，必须初始化。
            if (compareAndSetHead(new Node())) // 原子地设置头结点
                tail = head; // 尾结点也指向头结点
        } else {
            node.prev = t;
            if (compareAndSetTail(t, node)) {  // 步骤 1
                t.next = node; // 步骤 2
 // 在把新结点设置为tail后才能更新前驱的next字段，这样，即使CAS失败了也不会影响原来的连接关系。
                return t;
            }
        }
    }
}
</code></pre>
<h3>4 acquire</h3>
<p>acquire方法不提供绝对公平的保证，因为现在在加入队列之前先进行tryAcquire操作，如果这个线程先于头结点锁定，那么头结点就只能继续等待了。这种情形称为闯入。</p>
<p>这个acquire之所以先尝试获取是为了在无竞争的情况下提高性能，并可以实现非公平的获取。如果要保证绝对的公平性，则可以在子类实现的tryAcquire方法里判断当前线程是否是头结点，是则尝试获取，不是则直接返回false。</p>
<pre><code>// 以独占模式获取
public final void acquire(int arg) {
    if (!tryAcquire(arg) &amp;&amp; // 首先尝试获取
        acquireQueued(addWaiter(Node.EXCLUSIVE), arg))
      // 失败后加入等待队列，再从队列里再次尝试获取；成功获取后才返回，
      // 返回的boolean表示线程是否曾经被中断。

      // 在acquireQueued方法里，线程可能被反复park、unpark，直到获取锁。
      selfInterrupt(); // 重新设置中断状态位，是否执行取决于acquireQueued的返回值
}

final boolean acquireQueued(final Node node, int arg) {
    boolean failed = true;
    try {
        boolean interrupted = false; // 线程是否曾被中断是由这个变量记录的。
        for (;;) { // 死循环，用于acquire失败后重试
            final Node p = node.predecessor();
            if (p == head &amp;&amp; tryAcquire(arg)) {// 前驱是头结点，继续尝试获取
                setHead(node);
                p.next = null; // help GC
                failed = false;
                return interrupted;
            }
            // 检测是否需要等待，如果需要，则park当前线程
            // 只有前驱在等待时才进入等待，否则继续重试
            if (shouldParkAfterFailedAcquire(p, node) &amp;&amp;
                parkAndCheckInterrupt()) // 线程进入等待，需要其他线程来唤醒这个线程以继续执行
                interrupted = true;   // 只要线程在等待过程中被中断过一次就会记录下来
        }
    } finally {
        if (failed)
             // acquire失败，取消acquire
            cancelAcquire(node);
    }
}

/*
 * 这个方法是信号控制的核心。检查和更新没有成功获取的结点的状态。
 */
private static boolean shouldParkAfterFailedAcquire(Node pred, Node node) {
    int ws = pred.waitStatus;
    if (ws == Node.SIGNAL)
      // 前驱结点也在等待，说明这是一个稳定的等待状态。
        return true ;
    if (ws &gt; 0) {
      // 前驱结点已取消，向前遍历直到找到一个非取消结点。
        do {
            node.prev = pred = pred.prev;
        } while (pred.waitStatus &gt; 0);
        // 把找到的结点的后继指向node，那么当前pred与node之间的已取消结点就不再被引用了，可以被垃圾回收。
        pred.next = node;
    } else {
      // 前驱的状态必是 0 或 PROPAGATE之一。表明需要一个信号，但不park先。
      // 调用者需要重试来确保它在park之前没法获取。
        compareAndSetWaitStatus(pred, ws, Node.SIGNAL);
    }
    return false;
}

private final boolean parkAndCheckInterrupt() {
       // park当前执行线程， 其他线程unpark这个线程后继续执行
    LockSupport.park( this);
    return Thread.interrupted();
}
</code></pre>
<h3>5 release</h3>
<pre><code>public final boolean release(int arg) {
  if (tryRelease(arg)) {
    Node h = head;
    if (h != null &amp;&amp; h.waitStatus != 0)
      unparkSuccessor(h);
    return true;
  }
  return false;
}

private void unparkSuccessor(Node node) {
    /*
     * 如果status是负的（比如，可能需要信号）尝试清除预期的信号。
     * 如果这失败了或status被其他等待线程修改也是没关系的。
     */
    int ws = node.waitStatus;
    if (ws &lt; 0)
        compareAndSetWaitStatus(node, ws, 0);

    /*
     * 准备unpark的线程在后继里持有，一般就是下一个结点。
     * 但如果被取消或是空，从tail向后遍历来找到实际的非取消后继。
     */
    Node s = node.next;
    if (s == null || s.waitStatus &gt; 0) {
      // 没有直接后继或直接后继不需要通知
        s = null;

        // 从tail向后遍历，查找需要通知的结点
        for (Node t = tail; t != null &amp;&amp; t != node; t = t.prev)
             // 找到一个后不跳出循环是为了找到最老的需要通知的结点。
            if (t.waitStatus &lt;= 0)
                s = t;
    }
    if (s != null) // 结点不为null，唤醒后继的等待线程
        LockSupport.unpark(s.thread);
}
</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 13:50:08</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/thread/" title="thread">thread</a>, <a href="https://www.iamivan.net/tag/node/" title="node">node</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b%e8%af%ad%e8%a8%80/" title="编程语言">编程语言</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>java.util.concurrent解析——AbstractQueuedSynchronizer队列管理的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlB8VVz.html" rel="bookmark">java&period;util&period;concurrent解析&mdash;&mdash;AbstractQueuedSynchronizer综述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				尽管JVM在并发上已经做了很多优化工作,如偏向锁.轻量级锁.自旋锁等等.但是基于Synchronized wait notify实现的同步机制还是无法满足日常开发中.原生同步机制在时间和空间上的开销也一直备受诟病.为了提升Java程序在并发场景下的性能.扩展性和健壮性,java.util.concurrent的使用必不可少.java.util.concurrent 包含许多线程安全.测试良好.高性能的并发构建块.通过使用java.util.concurrent,开发人员可以提高并发类的线程安全.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Y69Xb.html" rel="bookmark">java&period;util&period;concurrent&period;Queue 并发队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. ConcurrentLinkedQueue Queue的一个线程安全实现,见下: public class ConcurrentLinkedQueue&lt;E&gt; extends AbstractQueue&lt;E&gt;   implements Queue&lt;E&gt;, java.io.Serializable {} 2.BlockingQueue 阻塞队列 这是一个线程安全的接口,见下: public interface BlockingQueue&lt;E&gt; extend			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWRR6p.html" rel="bookmark">java&period;util&period;concurrent解析&mdash;&mdash;ThreadPoolExecutor源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				任何一种语言.框架,线程都是非常重要的一部分.要想实现异步就需要通过异步线程,但是频繁地创建销毁线程会带来较大的性能开销,而线程池就是为解决这一问题而出现的.简单来说线程池有以下几大优势: 降低资源开销:通过复用已经创建的线程,降低线程频繁创建.销毁带来的资源开销和性能损耗 快速启动任务:通过复用已有线程,快速启动任务 易于管理:线程池可以统一管理.分配.调优和监控 Java中的线程池是基于ThreadPoolExecutor实现的,我们使用的ExecutorService的各种线程池策略都是基			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkeGN7b.html" rel="bookmark">java&period;util&period;concurrent解析&mdash;&mdash;FutureTask源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. Runnable.Callable.Future.FutureTask的区别与联系 和Java异步打交道就不能回避掉Runnable,Callable,Future,FutureTask等类,首先来介绍下这几个类的区别. 1.1 Runnable Runnable接口是我们最熟悉的,它只有一个run函数.然后使用某个线程去执行该runnable即可实现多线程,Thread类在调用start()函数后就是执行的是Runnable的run()函数.Runnable最大的缺点在于run函数没有返			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOw5d5z.html" rel="bookmark">剖析java&period;util&period;concurrent锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 导言 程序的性能分析是应用程序开发过程中的一个重要方面.这个工作一般是由一些专业人员来完成的,他们的目标是在一个特定的平台上,提高代码的性能.当程序是运行在多核平台的多线程或者并行程序的时候,提高性能这个问题就变得更加困难了.因为在这样的情况下,不仅需要考虑代码的性能,还需要考虑代码的可伸缩性. 随着Java 5中引入了java.util.concurrent (JUC)包,在Java语言中出现了一种新的锁.JUC包使用得越来越普遍,因为更多的应用程序需要为了多核系统而开发或仔细地调优.虽			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBylvb.html" rel="bookmark">【JAVA秒会技术之多线程】多线程java&period;util&period;concurrent详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.多线程 1.操作系统有两个容易混淆的概念,进程和线程. 进程:一个计算机程序的运行实例,包含了需要执行的指令:有自己的独立地址空间,包含程序内容和数据:不同进程的地址空间是互相隔离的:进程拥有各种资源和状态信息,包括打开的文件.子进程和信号处理. 线程:表示程序的执行流程,是CPU调度执行的基本单位:线程有自己的程序计数器.寄存器.堆栈和帧.同一进程中的线程共用相同的地址空间,同时共享进进程锁拥有的内存和其他资源. 2.Java标准库提供了进程和线程相关的API,进程主要包括表示进程的jav			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMl5Lqp.html" rel="bookmark">java&period;util&period;concurrent包源码阅读（一） 源码包的结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				准备花点时间阅读一下java.util.concurrent这个包里面的java代码,大致看了一下,这个包我个人觉得大致可以分为五个部分(如有不对之处,还望指正) 第一部分 Aomic数据类型 这部分都被放在java.util.concurrent.atomic这个包里面,实现了原子化操作的数据类型,包括 Boolean, Integer, Long, 和Referrence这四种类型以及这四种类型的数组类型. 第二部分 锁 这部分都被放在java.util.concurrent.lock这个包			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo6O03z.html" rel="bookmark">关于java&period;util&period;concurrent您不知道的 5 件事，第1部分</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通过并发 Collections 进行多线程编程 Concurrent Collections 是 Java 5 的巨大附加产品,但是在关于注释和泛型的争 执中很多 Java 开发人员忽视了它们.此外(或者更老实地说),许多开发人员避免使用这个 数据包,因为他们认为它一定很复杂,就像它所要解决的问题一样. 事实上,java.util.concurrent 包含许多类,能够有效解决普通的并发问题,无需复杂工 序.阅读本文,了解 java.util.concurrent 类,比如 CopyOnWri			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZdaAoM.html" rel="bookmark">Java7 java&period;util&period;concurrent 并发包计划</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接,译文链接,译者:DOM,校对:郑旭东  Java7发布版本的具体计划应该开始了,之前经常有人问我们关于JSR166的后续计划包含哪些内容.下面是目前暂定的内容,欢迎提出你们的见 解和意见. 1.Phasers    一个通用的内存屏障实现. 2.LinkedTransferQueue (and TransferQueue interface)   一个具有非阻塞,阻塞和同步接口的队列. 3. ConcurrentReferenceHashMap   并发Hash Map,其键和值可以是			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBZvOb.html" rel="bookmark" class="title">link中类似C&plus;&plus;的流运算是怎么实现的？能不能实现字符串输出流？</a>
					<div>
						问题描述 link中类似C++的流运算是怎么实现的?能不能实现字符串输出流? link中类似C++的流运算是怎么实现的?能不能实现字符串输出流? 解决方案 http://kb.cnblogs.com/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvqWWb.html" rel="bookmark" class="title">金山WPS文字中拆分单元格的小技巧</a>
					<div>
						记得在WPS2000专业版中的表格单元格拆分中有一个选项,可以把拆分方法设置为&quot;参照右(或上.下.左)边单元&quot;(如图1): 图1 而在WPS文字2005中,这一功能也消失了(微软的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrdjmz.html" rel="bookmark" class="title">谈谈CMS内容管理系统的两种方案：XSL&plus;XML和HTML &lpar;二&rpar;</a>
					<div>
						xml 上篇讲到了XSL和XML如何在客户端浏览.也是CMS内容管理系统内容发布的一种形式,即XSL(模版)+XML(内容).     但是现实情况是由客户端浏览器不支持,这样做还会给服务器造成一定的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKyjOp.html" rel="bookmark" class="title">漫谈Java数据库存取技术</a>
					<div>
						数据|数据库 IT技术日新月异,新技术的出现令人目不暇接,似乎每一天都在产生着新名词.不过归根结底IT所要实现的价值不外乎数据收集,然后再以客户希望的形式展示给客户而已.因此数据存取技术也就成了一个永 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmeVBp.html" rel="bookmark" class="title">在ASP应用中验证用户身份&lpar;5&rpar;</a>
					<div>
						五.会话终止 当ASP会话结束时会运行global.asa中的Session_OnEnd方法,可以在这里删除保存在Application(&quot;Users&quot;)数组中由于超时而被终止会话 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKwlyp.html" rel="bookmark" class="title">Rafy领域实体框架示例&lpar;1&rpar; 转换传统三层应用程序</a>
					<div>
						Rafy 领域实体框架发布后,虽然有帮助文档,许多朋友还是反映学习起来比较复杂,希望能开发一个示例程序,展示如何使用 Rafy 领域实体框架所以,本文通过使用 Rafy 领域实体框架来改造一个传统的三 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx4eKb.html" rel="bookmark" class="title">把Vmware映像转为Virtual PC映像的办法</a>
					<div>
						Vmware与Virtual PC是现在两种最流行的虚拟机软件,若要分别在两个软件上一个一个的安装系统,真是麻烦.现在有让你直接把Vmware映像直接转为Virtual PC映像的办法,想不想试一下呢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxXJkb.html" rel="bookmark" class="title">从头构建Apache Geronimo</a>
					<div>
						简介 Apache Geronimo 作为一个开放源码解决方案正在迅速发展,新的 1.0 版本已经完成了,Geronimo 已经度过了原始时期.像 Geronimo 这样的大型开放源码解决方案总是受到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlmWkb.html" rel="bookmark" class="title">演化架构与紧急设计&colon; 组合方法和 SLAP</a>
					<div>
						简介:如何在陈旧的代码库中找出隐藏的设计?本文讨论两种对于代码结构很重要的模式:组合方法 和单一抽象层.对代码应用这些原则有助于找到以前隐藏的可重用资产,有助于把现有的代码抽象为成熟的框架. 在这个  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balAXqz.html" rel="bookmark" class="title">PS快速制作出视觉特效下雨效果简单新手教程</a>
					<div>
						教程在PS里面制作简单的下雨效果,比较快速简单的制作下雨特效,主要是用滤镜来制作,新手同学们也可以学会, 一起来制作一下吧! photoshop教程效果图: (1)首先我们打开 - PS 这个大家都会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2qWkb.html" rel="bookmark" class="title">WPS2016如何输入高等数学定积分公式</a>
					<div>
						  1.打开需要编辑的WPS文档,点击工具栏的&quot;插入&quot;→公式 2.然后就会跳转到&quot;公式编辑器&quot;,在公式编辑器里我们可以编辑各类的高等数学公式,这里以定积分公式为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91yDKM.html" rel="bookmark" class="title">Win8愤怒的小鸟星战版更新啦</a>
					<div>
						  自从Rovio于去年11月初发布Windows 8平台的&lt;愤怒小鸟星战版&gt;后就再也没有更新过,Hoth关卡始终显示coming soon,而其他iOS和Android平台早在3个月前就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bad0BQz.html" rel="bookmark" class="title">如何在电脑中通过iTunes更新iPhone上的应用程序</a>
					<div>
						  如何在电脑中通过iTunes更新iPhone上的应用程序       1.用手机数据线将iPhone连接电脑,手机上会出现提示,点击&quot;信任&quot;; 2.双击打开iTunes; 3. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o2mmb.html" rel="bookmark" class="title">Win7轻松删去照片里的个人信息</a>
					<div>
						  现在大部分的朋友在拍摄照片的时候使用的都是数码相机,一般都会默认保留等多种信息,如果需要将这些照片传播或共享出去,势必需要考虑删除其中的某些隐私信息.手工删除的方法并不复杂,打开属性对话框,切换到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGL3wp.html" rel="bookmark" class="title">B计划数据恢复软件恢复格式化压缩文件教程</a>
					<div>
						  1.ZIP RAR压缩格式化前后所在的文件系统都是NTFS/EXFat/FAT32之一,并且格式化的ZIP RAR压缩文件大小和位置没有改变. 2.如果ZIP RAR压缩文件之前文件系统是NTFS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGoW6p.html" rel="bookmark" class="title">Mac怎么安装字体</a>
					<div>
						  第一步:首先是下载您需要的字体,需要说明的是,windows系统下和苹果系统下字体的格式都是统一被识别的 第二步:选择安装即可,就能安装您需要的字体了. 第三步:如何管理字体. 第四步:选择你需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXPZjp.html" rel="bookmark" class="title">U盘隐藏分区详细介绍</a>
					<div>
						  现在用U盘来启动安装系统可谓是很普遍了,而且U盘的启动文件一般是安装在U盘的隐藏分区的,可以防止病毒的入侵.现在就来详细介绍一下U盘的这个隐藏分区. 其实U盘的隐藏分区也叫做ud文件系统,ud文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NLYrM.html" rel="bookmark" class="title">OpenDocMan 1&period;2&period;6&period;1发布 文档管理系统</a>
					<div>
						OpenDocMan 是一个基于Web的多功能http://www.aliyun.com/zixun/aggregation/7453.html&quot;&gt;文档管理系统(DMS),采用PHP编 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrgBOM.html" rel="bookmark" class="title">神奇的vfork</a>
					<div>
						一段神奇的代码 在论坛里看到下面一段代码: int createproc(); int main() { pid_t pid=createproc(); printf(&quot;%d\n&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NBDDz.html" rel="bookmark" class="title">前端开发：工具和流程</a>
					<div>
						在dailyReport项目中,我通过SpringBoot + Mongodb + Redis构建了后端RESTful接口,现在需要客户端展现了,但是我的web和移动开发都是初学者,只能从头学起. 在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVGv5b.html" rel="bookmark" class="title">php-PHP做数据缓存有哪几种方式？</a>
					<div>
						问题描述 PHP做数据缓存有哪几种方式? 大神,我想问一下PHP做数据缓存有哪几种方式?能详细说明一下吗?最好能说明一下原理,谢谢! 解决方案 大都是生成缓存文件,在访问该页面时,验证该文件的修改时间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ARE3z.html" rel="bookmark" class="title">调试-IntelliJ IDEA Community Edition下go语言无法debug</a>
					<div>
						问题描述 IntelliJ IDEA Community Edition下go语言无法debug IntelliJ IDEA Community Edition下go语言无法debug不能设置断点?这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKP7rz.html" rel="bookmark" class="title">李开复</a>
					<div>
						李开复作为天使投资人,在送给一对新人婚姻的http://www.aliyun.com/zixun/aggregation/35850.html&quot;&gt;投资协议与祝福中说: &quot;创业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1r73op.html" rel="bookmark" class="title">java算法-Longest Palindromic Substring 最长回文子串问题？JAVA</a>
					<div>
						问题描述 Longest Palindromic Substring 最长回文子串问题?JAVA public class Solution { public String longestPalind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RKqkb.html" rel="bookmark" class="title">web service 自定义拦截器</a>
					<div>
						客户端拦截器: package com.xh.ws.interceptor; import java.util.List; import javax.xml.namespace.QName; impo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAOEQM.html" rel="bookmark" class="title">谷歌公司将在安卓系统的地图应用程序中增加世界最大的博物馆体系史密森尼博物院的室内游览图</a>
					<div>
						史密森尼博物院将可以在http://www.aliyun.com/zixun/aggregation/626.html&quot; style=&quot;line-height: 1.6;&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLXg8M.html" rel="bookmark" class="title">黑暗中前行&mdash;&mdash;我当站长的第一桶金</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 我学的信息管理专业,2011年6月从三流大学毕业后,就在一家教育培训公司做seo.刚去的时候算实习,月薪1000整.第一个星期是没有工资的,我自己买了笔 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0AeEz.html" rel="bookmark" class="title">JSP开发入门&lpar;二&rpar;----JSP语法的基本原理&lowbar;JSP编程</a>
					<div>
						安装之后,接下来我们要讨论JSP的语法.如果要偷懒,你可以下载语法卡而如果你不熟悉 Java的程序设计,你可能会想要参考Sun的使用手册:然而,网站建立者不应该做太多的Java发展.除了几个函式呼叫之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNv84yM.html" rel="bookmark" class="title">详解C&plus;&plus;中的内联函数和函数重载&lowbar;C 语言</a>
					<div>
						内联函数(内嵌函数,内置函数) 调用函数时需要一定的时间和空间的开销.C++提供一种提高效率的方法,即在编译时将函数调用处用函数体替换,类似于C语言中的宏展开.这种在函数调用处直接嵌入函数体的函数称为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOW9qb.html" rel="bookmark" class="title">易名中国9月注册CN域名享3年免费</a>
					<div>
						自9月1日起,国内著名域名注册服务商易名中国推出了CN域名续费赠送活动,获得了用户的一致好评,用户只要在9月1日-30日期间,新注册或者续注CN域名或&quot;.中国&quot;等中文域名3-4年. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
